package net.t2code.lib.Spigot.system;

import net.t2code.lib.Spigot.Lib.messages.send;
import net.t2code.lib.Spigot.Lib.minecraftVersion.MCVersion;
import net.t2code.lib.Spigot.Lib.minecraftVersion.NMSVersion;
import net.t2code.lib.Spigot.Lib.plugins.PluginCheck;
import net.t2code.lib.Util;
import net.t2code.luckyBox.api.LuckyBoxAPI;
import org.bukkit.Bukkit;
import org.bukkit.OfflinePlayer;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;

import java.io.*;
import java.nio.file.Files;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

public class CreateReportLog {
    protected static void create(CommandSender sender) {
        send.sender(sender, T2CodeMain.getPrefix() + " §6A DebugLog is created...");
        String timeStampFile = new SimpleDateFormat("HH_mm_ss-dd_MM_yyyy").format(Calendar.getInstance().getTime());

        File directory = new File(T2CodeMain.getPath() + "/DebugLogs");
        if (!directory.exists()) {
            directory.mkdir();
        }

        File file = new File(T2CodeMain.getPath(), "/DebugLogs/T2CodeLog.txt");
        PrintWriter pWriter = null;
        try {
            pWriter = new PrintWriter(new FileWriter(file.getPath()));
            String timeStamp = new SimpleDateFormat("HH:mm:ss dd.MM.yyyy").format(Calendar.getInstance().getTime());
            pWriter.println("Created on: " + timeStamp);
            pWriter.println();
            pWriter.println("Server Bukkit version: " + MCVersion.isBuckitVersion);
            pWriter.println("Server run on: " + MCVersion.isVersion);
            pWriter.println("Server NMS: " + NMSVersion.isNMS);
            pWriter.println();
            pWriter.println("Online Mode: " + Bukkit.getOnlineMode());
            pWriter.println("Worlds: " + Bukkit.getWorlds());
            pWriter.println("OP-Player:");
            for (OfflinePlayer player : Bukkit.getOperators()) {
                pWriter.println(" - Player: " + player.getName() + " - " + player.getUniqueId());
            }
            pWriter.println();
            if (Vault.vaultEnable) {
                pWriter.println("Vault: " + Bukkit.getPluginManager().getPlugin("Vault").getName() + " - " + Bukkit.getPluginManager().getPlugin("Vault").getDescription().getVersion());
            } else pWriter.println("Vault: not connected");
            if (T2CodeMain.getEco() != null) {
                String st = T2CodeMain.getEco().getName();
                if (T2CodeMain.getEco().getName().equals("CMIEconomy")) st = "CMI";
                if (Bukkit.getPluginManager().getPlugin(st) != null) {
                    pWriter.println("Economy: " + T2CodeMain.getEco().isEnabled() + " - " + st + " - " + Bukkit.getPluginManager().getPlugin(st).getDescription().getVersion());
                } else pWriter.println("Economy: " + T2CodeMain.getEco().isEnabled() + " - " + st);
            } else pWriter.println("Economy: not connected via vault");
            if (T2CodeMain.getPerm() != null) {
                if (Bukkit.getPluginManager().getPlugin(T2CodeMain.getPerm().getName()) != null) {
                    pWriter.println("Permission: " + T2CodeMain.getPerm().isEnabled() + " - " + T2CodeMain.getPerm().getName() + " - " + Bukkit.getPluginManager().getPlugin(T2CodeMain.getPerm().getName()).getDescription().getVersion());
                } else pWriter.println("Permission: " + T2CodeMain.getPerm().isEnabled() + " - " + T2CodeMain.getPerm().getName());
            } else pWriter.println("Permission: not connected via vault");
            pWriter.println();
            pWriter.println("Java: " + System.getProperty("java.version"));
            pWriter.println("System: " + System.getProperty("os.name"));
            pWriter.println("System: " + System.getProperty("os.version"));
            pWriter.println("User Home: " + System.getProperty("user.home"));
            pWriter.println();
            pWriter.println("T2CodeLib: " + T2CodeMain.getPlugin().getDescription().getVersion());
            pWriter.println();
            if (PluginCheck.luckyBox()) {
                pWriter.println("T2C-PremiumPlugins: ");
                pWriter.println("T2C-LuckyBox UID: " + LuckyBoxAPI.getUID());
                pWriter.println("T2C-LuckyBox RID: " + LuckyBoxAPI.getRID());
                pWriter.println("T2C-LuckyBox DID: " + LuckyBoxAPI.getDID());
                pWriter.println("T2C-LuckyBox isP: " + LuckyBoxAPI.isP());
                pWriter.println("T2C-LuckyBox isV: " + LuckyBoxAPI.isV());
                pWriter.println();
            }
            pWriter.println("Plugins: ");
            for (Plugin pl : Bukkit.getPluginManager().getPlugins()) {
                pWriter.println(" - " + pl.getName() + " - " + pl.getDescription().getVersion() + " - Enabled: " + pl.isEnabled() + " - Autors: " + pl.getDescription().getAuthors() + " - Website: " + pl.getDescription().getWebsite());
            }
        } catch (IOException ioe) {
            ioe.printStackTrace();
        } finally {
            if (pWriter != null) {
                pWriter.flush();
                pWriter.close();
            }
        }

        String filePath = T2CodeMain.getPath() + "/DebugLogs/T2CodeLog.txt";
        String log = "logs/latest.log";
        String zipPath = "plugins/T2CodeLib/DebugLogs/T2CLog-" + timeStampFile + ".zip";
        try (ZipOutputStream zip = new ZipOutputStream(new FileOutputStream(zipPath))) {
            File fileToZip = new File(filePath);
            zip.putNextEntry(new ZipEntry(fileToZip.getName()));
            Files.copy(fileToZip.toPath(), zip);

            addFileToZip("", "logs/latest.log", zip, false);

            for (String pl : Util.getT2cPlugins()){
                pluginToDebug(pl, zip);
            }

            //pluginToDebug("T2C-LuckyBox", zip);
            //pluginToDebug("WonderBagShop", zip);
            //pluginToDebug("CommandGUI", zip);
            //pluginToDebug("OPSecurity", zip);
            //pluginToDebug("PaPiTest", zip);
            //pluginToDebug("PlotSquaredGUI", zip);
            //pluginToDebug("T2C-Alias", zip);
            //pluginToDebug("T2C-AutoResponse", zip);
            //
            //pluginToDebug("LoreEditor", zip);
            //pluginToDebug("Booster", zip);
            //pluginToDebug("AntiMapCopy", zip);
            //pluginToDebug("AntiCopy", zip);

            zip.closeEntry();
            zip.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
        file.delete();
        if (sender instanceof Player) {
            send.sender(sender, T2CodeMain.getPrefix() + " §6A DebugLog zip has been created. you can find it on in the files on your server under the path: §e" + zipPath);
            send.console(T2CodeMain.getPrefix() + " §6A DebugLog zip has been created. you can find it on in the files on your server under the path: §e" + zipPath);
        } else send.sender(sender, T2CodeMain.getPrefix() + " §6A DebugLog zip has been created. you can find it on in the files on your server under the path: §e" + zipPath);

    }

    private static void pluginToDebug(String pluginName, ZipOutputStream zip) throws IOException {
        if (PluginCheck.pluginCheck(pluginName)) {
            Plugin plugin = Bukkit.getPluginManager().getPlugin(pluginName);
            File plConfigs = new File(plugin.getDataFolder().getPath());
            if (plConfigs.exists()) {
                addFolderToZip("T2Code-Plugins", plugin.getDataFolder().getPath(), zip);
            }
            File f = new File("plugins/");
            File[] fileArray = f.listFiles();

            for (File config : fileArray) {
                if (config.getName().contains(pluginName) && config.getName().contains(".jar")) {
                    addFileToZip("T2Code-Plugins", config.getPath(), zip, false);
                }
            }
        }
    }

    private static void addFolderToZip(String path, String srcFolder, ZipOutputStream zip) throws IOException {
        File folder = new File(srcFolder);
        if (folder.list() == null) {
            addFileToZip(path + "/" + folder.getName(), srcFolder, zip, false);
        } else if (folder.list().length == 0) {
            addFileToZip(path, srcFolder, zip, true);
        } else {
            for (String fileName : folder.list()) {
                if (path.equals("")) {
                    addFileToZip(folder.getName(), srcFolder + "/" + fileName, zip, false);
                } else {
                    addFileToZip(path + "/" + folder.getName(), srcFolder + "/" + fileName, zip, false);
                }
            }
        }
    }

    private static void addFileToZip(String path, String srcFile, ZipOutputStream zip, boolean flag) throws IOException {
        File folder = new File(srcFile);
        if (flag) {
            zip.putNextEntry(new ZipEntry(path + "/" + folder.getName() + "/"));
        } else {
            if (folder.isDirectory()) {
                addFolderToZip(path, srcFile, zip);
            } else {
                byte[] buf = new byte[1024];
                int len;
                FileInputStream in = new FileInputStream(srcFile);

                if (path.equals("")) {
                    zip.putNextEntry(new ZipEntry((folder.getName())));
                } else {
                    zip.putNextEntry(new ZipEntry((path + "/" + folder.getName())));
                }

                while ((len = in.read(buf)) > 0) {
                    try {
                        zip.write(buf, 0, len);
                    } catch (Exception ex) {
                        ex.printStackTrace();
                    }
                }
            }
        }
    }
}
